## rust-fips203-ffi 0.2.1

=== tests/Makefile ===
SO_LOCATION = ../../target/debug
SIZES = 512 768 1024
FRAMES = encaps_key decaps_key ciphertext encaps decaps keygen
# should derive SONAME somehow, e.g. from CARGO_PKG_VERSION_MAJOR
SONAME = 0

BASELINES=$(foreach sz, $(SIZES), baseline-$(sz))
CHECKS=$(foreach sz, $(SIZES), runtest-$(sz))

check: $(CHECKS)

$(SO_LOCATION)/libfips203.so.$(SONAME): $(SO_LOCATION)/libfips203.so
	ln -s $< $@

runtest-%: baseline-% $(SO_LOCATION)/libfips203.so.$(SONAME)
	LD_LIBRARY_PATH=$(SO_LOCATION) ./$<

baseline-%: baseline.c ../fips203.h
	$(CC) -o $@ -g -D MLKEM_size=$* $(foreach v, $(FRAMES),-D MLKEM_$(v)=ml_kem_$*_$(v)) -Werror -Wall -pedantic -L $(SO_LOCATION) $< -Wall -lfips203

clean:
	rm -f $(BASELINES)

.PHONY: clean check

=== debian/changelog ===
rust-fips203-ffi (0.2.1-4) unstable; urgency=medium

  * Package fips203-ffi 0.2.1 from crates.io using debcargo 2.6.1
  * drop --link-from-system when building, avoid linkfarm

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 18 Jun 2024 10:34:44 -0400

rust-fips203-ffi (0.2.1-3) unstable; urgency=medium

  * Package fips203-ffi 0.2.1 from crates.io using debcargo 2.6.1
  * improve build-time and runtime test of shared object

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 11 Jun 2024 18:42:45 -0400

rust-fips203-ffi (0.2.1-2) unstable; urgency=medium

  * Package fips203-ffi 0.2.1 from crates.io using debcargo 2.6.1
  * No-op source-only re-upload for Debian Testing Migration.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 11 Jun 2024 09:09:53 -0400

rust-fips203-ffi (0.2.1-1) unstable; urgency=medium

  * Package fips203-ffi 0.2.1 from crates.io using debcargo 2.6.1

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 06 Jun 2024 14:53:52 +0200

=== debian/control ===
Source: rust-fips203-ffi
Section: rust
Priority: optional
Build-Depends: debhelper (>= 13),
 dh-cargo (>= 25),
 dh-sequence-python3,
 cargo:native,
 rustc:native (>= 1.70),
 python3-all,
 libstd-rust-dev,
 librust-fips203-0.2+default-dev (>= 0.2.1-~~),
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/fips203-ffi]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/fips203-ffi
X-Cargo-Crate: fips203-ffi
Rules-Requires-Root: no
Homepage: https://crates.io/crates/fips203-ffi

Package: libfips203-0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for FIPS 203 (ML-KEM) IPD
 This package contains a dynamic library (shared object) implementing
 the Module-Lattice-Based Key-Encapsulation Mechanism, also known as
 ML-KEM or FIPS 203.
 .
 It is written in pure Rust with minimal and mainstream dependencies,
 and without any unsafe code. All three security parameter sets are
 fully supported and tested. The implementation operates in
 constant-time (outside of rho, which is part of the encapsulation key
 sent across the trust boundary in the clear), and focuses on
 correctness, simplicity, security, and a stable API.
 .
 See <https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.203.ipd.pdf>
 for a full description of the target functionality.

Package: libfips203-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends},
 libfips203-0 (= ${binary:Version}),
Description: Library for FIPS 203 (ML-KEM) IPD - development files
 This package enables a C programmer to use a dynamic library (shared
 object) implementing the Module-Lattice-Based Key-Encapsulation
 Mechanism, also known as ML-KEM or FIPS 203.
 .
 The library is written in pure Rust with minimal and mainstream
 dependencies, and without any unsafe code. All three security
 parameter sets are fully supported and tested. The implementation
 operates in constant-time (outside of rho, which is part of the
 encapsulation key sent across the trust boundary in the clear), and
 focuses on correctness, simplicity, security, and a stable API.
 .
 See <https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.203.ipd.pdf>
 for a full description of the target functionality.

Package: python3-fips203
Architecture: any
Section: python
Provides:
 ${python3:Provides},
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
 libfips203-0 (= ${binary:Version}),
Description: FIPS 203 (ML-KEM) IPD - Python module
 This package enables a Python programmer to easily use the
 Module-Lattice-Based Key-Encapsulation Mechanism, also known as
 ML-KEM or FIPS 203.
 .
 See <https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.203.ipd.pdf>
 for a full description of the target functionality.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

export CARGO_HOME = $(CURDIR)/debian/cargo_home
export DEB_CARGO_CRATE = fips203-ffi_$(DEB_VERSION_UPSTREAM)

CARGO = /usr/share/cargo/bin/cargo

%:
	dh $@ --with python3

override_dh_auto_configure:
	$(CARGO) prepare-debian /usr/share/cargo/registry

override_dh_auto_build:
	$(CARGO) build --release
	# adjust the filename built:
	debian/scripts/post-build ${DEB_VERSION_UPSTREAM}

execute_after_dh_auto_test:
	cd tests && make

=== debian/tests/control ===
Test-Command: cd tests && make AS_INSTALLED=true
Depends:
 build-essential,
 libfips203-dev,

=== debian/watch ===
version=4
opts=filenamemangle=s/.*\/(.*)\/download/fips203-ffi-$1\.tar\.gz/g,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/ \
https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=crates.io/fips203-ffi .*/crates/fips203-ffi/@ANY_VERSION@/download

## rust-fips203-ffi 0.4.1

=== tests/Makefile ===
#!/usr/bin/make -f

# Usage: (cargo build && cd tests && make)

# If the library and its development headers are installed system-wide,
# run the tests with:
#
#  (cd tests && make AS_INSTALLED=true)

SIZES = 512 768 1024
FRAMES = encaps_key decaps_key ciphertext encaps decaps keygen keygen_from_seed
# should derive SONAME somehow, e.g. from CARGO_PKG_VERSION_MAJOR
SONAME = 0

all: check

# adjustments for testing the local debug or release build:
ifneq ($(AS_INSTALLED),true)
SO_LOCATIONS = $(foreach w,.. ../..,$(foreach x,release debug,$w/target/$x $w/target/*/$x))
SO_LOCATION = $(dir $(firstword $(foreach d,$(SO_LOCATIONS),$(wildcard $d/libfips203.so))))
$(SO_LOCATION)libfips203.so.$(SONAME): $(SO_LOCATION)libfips203.so
	ln $< $@
COMPILE_FLAGS = -L $(SO_LOCATION) -I..
RUN_PREFIX = LD_LIBRARY_PATH=$(SO_LOCATION)
ADDITIONAL_RUN_DEPENDS = $(SO_LOCATION)libfips203.so.$(SONAME)
endif

BASELINES=$(foreach sz, $(SIZES), baseline-$(sz))
CHECKS=$(foreach sz, $(SIZES), runtest-$(sz))

check: $(CHECKS)

runtest-%: baseline-% $(ADDITIONAL_RUN_DEPENDS)
	$(RUN_PREFIX) ./$<

baseline-%: baseline.c ../fips203.h
	$(CC) -o $@ -g -D MLKEM_size=$* $(foreach v, $(FRAMES),-D MLKEM_$(v)=ml_kem_$*_$(v)) -Werror -Wall -pedantic $< -Wall $(COMPILE_FLAGS) -lfips203

clean:
	rm -f $(BASELINES) $(ADDITIONAL_RUN_DEPENDS)

.PHONY: clean check all

=== debian/changelog ===
rust-fips203-ffi (0.4.1-2) unstable; urgency=medium

  * Package fips203-ffi 0.4.1 from crates.io using debcargo 2.7.1
  * Fix up autopkgtests for python module

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 18 Oct 2024 11:38:26 -0400

rust-fips203-ffi (0.4.1-1) unstable; urgency=medium

  * Package fips203-ffi 0.4.1 from crates.io using debcargo 2.7.1

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 17 Oct 2024 17:18:06 -0400

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: rust-fips203-ffi
 Section: rust
 Priority: optional
-Build-Depends: debhelper (>= 13),
- dh-cargo (>= 25),
+Build-Depends: debhelper-compat (= 13),
+ dh-sequence-cargo,
  dh-sequence-python3,
- cargo:native,
- rustc:native (>= 1.70),
+ cargo:native <!nocheck>,
+ rustc:native (>= 1.70) <!nocheck>,
  python3-all,
- libstd-rust-dev,
- librust-fips203-0.2+default-dev (>= 0.2.1-~~),
+ libstd-rust-dev <!nocheck>,
+ librust-fips203-0.4+default-dev (>= 0.4.1-~~) <!nocheck>,
+ librust-rand-core-0.6+default-dev (>= 0.6.4-~~) <!nocheck>,
+ librust-rand-core-0.6+getrandom-dev (>= 0.6.4-~~) <!nocheck>
 Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Daniel Kahn Gillmor <dkg@fifthhorseman.net>
@@ -26,7 +28,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Description: Library for FIPS 203 (ML-KEM) IPD
+Description: Library for FIPS 203 (ML-KEM)
  This package contains a dynamic library (shared object) implementing
  the Module-Lattice-Based Key-Encapsulation Mechanism, also known as
  ML-KEM or FIPS 203.
@@ -38,7 +40,7 @@
  sent across the trust boundary in the clear), and focuses on
  correctness, simplicity, security, and a stable API.
  .
- See <https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.203.ipd.pdf>
+ See <https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.203.pdf>
  for a full description of the target functionality.
 
 Package: libfips203-dev
@@ -47,7 +49,7 @@
 Depends:
  ${misc:Depends},
  libfips203-0 (= ${binary:Version}),
-Description: Library for FIPS 203 (ML-KEM) IPD - development files
+Description: Library for FIPS 203 (ML-KEM) - development files
  This package enables a C programmer to use a dynamic library (shared
  object) implementing the Module-Lattice-Based Key-Encapsulation
  Mechanism, also known as ML-KEM or FIPS 203.
@@ -59,7 +61,7 @@
  encapsulation key sent across the trust boundary in the clear), and
  focuses on correctness, simplicity, security, and a stable API.
  .
- See <https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.203.ipd.pdf>
+ See <https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.203.pdf>
  for a full description of the target functionality.
 
 Package: python3-fips203
@@ -72,10 +74,10 @@
  ${python3:Depends},
  ${shlibs:Depends},
  libfips203-0 (= ${binary:Version}),
-Description: FIPS 203 (ML-KEM) IPD - Python module
+Description: FIPS 203 (ML-KEM) - Python module
  This package enables a Python programmer to easily use the
  Module-Lattice-Based Key-Encapsulation Mechanism, also known as
  ML-KEM or FIPS 203.
  .
- See <https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.203.ipd.pdf>
+ See <https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.203.pdf>
  for a full description of the target functionality.

## rust-fips203-ffi 0.4.3

=== tests/Makefile ===
--- 
+++ 
@@ -10,19 +10,28 @@
 SIZES = 512 768 1024
 FRAMES = encaps_key decaps_key ciphertext encaps decaps keygen keygen_from_seed
 # should derive SONAME somehow, e.g. from CARGO_PKG_VERSION_MAJOR
-SONAME = 0
+SONAME = libfips203.$(SO_EXT)
+
+OS := $(shell uname)
+
+    CXXFLAGS += -DLINUX
+ifeq ($(OS), Darwin)
+    SO_EXT = dylib
+else
+	SO_EXT = so
+endif
 
 all: check
 
 # adjustments for testing the local debug or release build:
 ifneq ($(AS_INSTALLED),true)
 SO_LOCATIONS = $(foreach w,.. ../..,$(foreach x,release debug,$w/target/$x $w/target/*/$x))
-SO_LOCATION = $(dir $(firstword $(foreach d,$(SO_LOCATIONS),$(wildcard $d/libfips203.so))))
-$(SO_LOCATION)libfips203.so.$(SONAME): $(SO_LOCATION)libfips203.so
-	ln $< $@
-COMPILE_FLAGS = -L $(SO_LOCATION) -I..
+SO_LOCATION = $(dir $(firstword $(foreach d,$(SO_LOCATIONS),$(wildcard $d/libfips203.$(SO_EXT)))))
+
+COMPILE_FLAGS = -Wl,-rpath,$(SO_LOCATION) -L $(SO_LOCATION) -I..
 RUN_PREFIX = LD_LIBRARY_PATH=$(SO_LOCATION)
-ADDITIONAL_RUN_DEPENDS = $(SO_LOCATION)libfips203.so.$(SONAME)
+#ADDITIONAL_RUN_DEPENDS = $(SO_LOCATION)libfips203.so.$(SONAME)
+ADDITIONAL_RUN_DEPENDS = $(SO_LOCATION)$(SONAME)
 endif
 
 BASELINES=$(foreach sz, $(SIZES), baseline-$(sz))

=== debian/changelog ===
rust-fips203-ffi (0.4.3-3) unstable; urgency=medium

  * Team upload.
  * Package fips203-ffi 0.4.3 from crates.io using debcargo 2.7.11
  * Regenerate d/control using current debcargo
  * Fix nocheck build (Closes: #1116899)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 01 Oct 2025 20:48:08 +0200

rust-fips203-ffi (0.4.3-2) unstable; urgency=medium

  * Package fips203-ffi 0.4.3 from crates.io using debcargo 2.7.7
  * Fix FTBFS due to upstream's Cargo.lock

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 06 Mar 2025 11:40:41 -0500

rust-fips203-ffi (0.4.3-1) unstable; urgency=medium

  * Package fips203-ffi 0.4.3 from crates.io using debcargo 2.7.7

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 05 Mar 2025 20:27:11 -0500

=== debian/control ===
--- 
+++ 
@@ -4,22 +4,20 @@
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-cargo,
  dh-sequence-python3,
- cargo:native <!nocheck>,
- rustc:native (>= 1.70) <!nocheck>,
+Build-Depends-Arch: cargo:native,
+ rustc:native (>= 1.70),
  python3-all,
- libstd-rust-dev <!nocheck>,
- librust-fips203-0.4+default-dev (>= 0.4.1-~~) <!nocheck>,
- librust-rand-core-0.6+default-dev (>= 0.6.4-~~) <!nocheck>,
- librust-rand-core-0.6+getrandom-dev (>= 0.6.4-~~) <!nocheck>
+ libstd-rust-dev,
+ librust-fips203-0.4+default-dev (>= 0.4.2-~~),
+ librust-rand-core-0.6+default-dev (>= 0.6.4-~~)
 Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Daniel Kahn Gillmor <dkg@fifthhorseman.net>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/fips203-ffi]
 Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/fips203-ffi
+Homepage: https://github.com/integritychain/fips203
 X-Cargo-Crate: fips203-ffi
-Rules-Requires-Root: no
-Homepage: https://crates.io/crates/fips203-ffi
 
 Package: libfips203-0
 Section: libs

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,7 @@
 	dh $@ --with python3
 
 override_dh_auto_configure:
+	rm -f Cargo.lock
 	$(CARGO) prepare-debian /usr/share/cargo/registry
 
 override_dh_auto_build:

=== debian/tests/control ===
--- 
+++ 
@@ -2,3 +2,8 @@
 Depends:
  build-essential,
  libfips203-dev,
+
+Test-Command: cd python && ./test/nist/keygen.py
+Depends:
+ librust-fips203-dev,
+ python3-fips203,

=== debian/watch ===
Version: 5

Source: https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=crates.io/fips203-ffi
Matching-Pattern:  .*/crates/fips203-ffi/@ANY_VERSION@/download
Filenamemangle: s/.*\/(.*)\/download/fips203-ffi-$1\.tar\.gz/g
Uversionmangle: s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/
